Option Strict Off
Option Explicit On 

Module TeleToken
    Public Declare Function TVTT_GetVersion Lib "TeleToken.dll" (ByRef Ver As Integer, _
                            ByRef SubVer As Integer, ByRef APIVer As Integer) As Integer

    Public Declare Function TVTT_FindToken Lib "TeleToken.dll" (ByRef TokenH As Integer, _
                            ByVal TimeOut As Integer, ByVal OwnerID As Integer, ByVal OwnerMsk As Byte, _
                            ByVal Skip As Byte, ByRef FeatureTblSize As Integer, _
                            ByRef FeatureTbl As Integer) As Integer

    Public Declare Function TVTT_FreeToken Lib "TeleToken.dll" (ByVal TokenH As Integer) As Integer

    Public Declare Function TVTT_StartSession Lib "TeleToken.dll" (ByVal TokenH As Integer, _
                            ByVal TimeOut As Integer) As Integer

    Public Declare Function TVTT_Talk Lib "TeleToken.dll" (ByVal TokenH As Integer, _
                            ByVal TimeOut As Integer, ByVal OutKey As Integer, _
                            ByRef OutDataA As Byte, ByRef OutDataB As Byte, _
                            ByRef InKey As Integer, ByRef InDataA As Byte, _
                            ByRef InDataB As Byte) As Integer

    Public Declare Function TVTT_EndSession Lib "TeleToken.dll" (ByVal TokenH As Integer) As Integer


    '------------------------------------------------------------------------------
    ' Stae biblioteki
    Public Const TVTT_BLOCK_A = 0                          ' staa definujca numer bloku danych przy szyfrowaniu pierwszego bloku danych - na potrzeby funkcji generujcej hasa tymczasowe
    Public Const TVTT_BLOCK_B = 1                          ' staa definujca numer bloku danych przy szyfrowaniu drugiego bloku danych - na potrzeby funkcji generujcej hasa tymczasowe
    Public Const TVTT_PC2T = 0                             ' staa definujca kierunek przesania wiadomoci z PC do Tokenu - na potrzeby funkcji generujcej hasa tymczasowe
    Public Const TVTT_T2PC = 1                             ' staa definujca kierunek przesania wiadomoci z Tokenu do PC - na potrzeby funkcji generujcej hasa tymczasowe
    Public Const TVTT_RAND_INIT_TBL_SIZE = (16 * 4)        ' staa definiujca rozmiar tablicy inicjujcej generator liczb pseudolosowych
    '------------------------------------------------------------------------------
    ' Kody bdw zwracane przez DLL
    Public Const TVTTS_OK = 0                              ' wszystko OK
    Public Const TVTTS_INVALID_HANDLE = &H100              ' niepoprany uchwyt na Token
    Public Const TVTTS_NULL_PTR = &H200                    ' adres na parametr jest wyzerowany
    Public Const TVTTS_BAD_PARAM = &H300                   ' podany parametr jest nie poprawny
    Public Const TVTTS_TOO_MANY_OPEN_TOKENS = &H400        ' za duo otwartych TeleTokenw
    Public Const TVTTS_USB_DOES_NOT_EXIST = &H500          ' nie znaleziono portu USB
    Public Const TVTTS_TOKEN_NOT_FOUND = &H600             ' Token nie znaleziony
    Public Const TVTTS_TIME_OUT = &H700                    ' przekroczenie czasu trwania operacji
    Public Const TVTTS_SEQ_EXPIRED = &H800                 ' sesja nie zostaa otwarta lub wygasa
    Public Const TVTTS_ALREADY_OPENED = &H900              ' sesja jest ju otwarta
    Public Const TVTTS_UNKNOWN_ERROR = &H1000              ' nieznany typ bdu - zwracany gdy nie da sie jednoznacznie zakwalifikowa bdu np.: operacja systemowa zwrcia nieoczekiwany kod bdu
    '------------------------------------------------------------------------------
    ' definicja pl tablicy opisujcej moliwoci Tokenu
    Public Const TVTTTI_ID = 0
    Public Const TVTTTI_NV_MEM_SIZE = 1
    Public Const TVTTTI_RAM_SIZE = 2
    Public Const TVTTTI_PROTECT_MEM_SIZE = 3
    Public Const TVTTTI_PASS_TABLE_SIZE = 4
    Public Const TVTTTI_BITS_PER_PASS = 5
    Public Const TVTTTI_COUNTERS = 6
    Public Const TVTTTI_BITS_PER_COUNTER = 7

    Public Const TVTTTI_TABLE_SIZE = 8

    ' definicja standardowych pl w drugim bloku danych
    Public Const TVTTD_CMD = 0
    Public Const TVTTD_STATUS = 0
    Public Const TVTTD_PARAM1 = 1
    Public Const TVTTD_PARAM2 = 2
    Public Const TVTTD_PARAM3 = 3
    Public Const TVTTD_AUTH = 4

    ' kody rozkazw TeleTokenu
    Public Const TVTTC_OPEN = &H1
    Public Const TVTTC_CLOSE = &H2
    Public Const TVTTC_FORMAT = &HF

    Public Const TVTTC_NVMEM_READ = &H11
    Public Const TVTTC_NVMEM_WRITE = &H12
    Public Const TVTTC_NVMEM_WRITE_PROTECT = &H13
    Public Const TVTTC_NVMEM_PROTECT = &H14
    Public Const TVTTC_VMEM_READ = &H91
    Public Const TVTTC_VMEM_WRITE = &H92

    Public Const TVTTC_ENCRYPT = &H21
    Public Const TVTTC_DECRYPT = &H22

    Public Const TVTTC_CNT_READ = &H31
    Public Const TVTTC_CNT_INC_READ = &H32
    Public Const TVTTC_CNT_DEC_READ = &H33
    Public Const TVTTC_CNT_WRITE = &H34
    Public Const TVTTC_CNT_INC_ENCRYPT_READ = &H35
    Public Const TVTTC_CNT_WRITE_CONFIG = &H36
    Public Const TVTTC_CNT_SET_CONFIG = &H37
    Public Const TVTTC_CNT_CLR_CONFIG = &H38

    Public Const TVTTC_PASS_WRITE = &H41
    Public Const TVTTC_PASS_WRITE_CONFIG = &H42
    Public Const TVTTC_PASS_SET_CONFIG = &H43
    Public Const TVTTC_PASS_CLR_CONFIG = &H44

    ' kody statusu TeleTokenu
    Public Const TVTTS_NO_OPEN = &H11
    Public Const TVTTS_EXPIRED = &H12
    Public Const TVTTS_DAMAGED = &H13

    Public Const TVTTS_NOT_SUPPORTED = &H21
    Public Const TVTTS_OUT_OF_RANGE = &H22
    Public Const TVTTS_PROTECTION_NOT_SUPPORTED = &H23

    Public Const TVTTS_PASS_NOT_PERMITTED = &H31
    Public Const TVTTS_NOT_PERMITTED = &H32
    Public Const TVTTS_ACCESS_EXPIRED = &H33

    ' bity konfiguracji hase
    Public Const TVTTPC0_TOKEN = &H1
    Public Const TVTTPC0_PASS_WRITE = &H2
    Public Const TVTTPC0_PASS_CONFIG = &H4
    Public Const TVTTPC0_MEM_READ = &H8
    Public Const TVTTPC0_MEM_WRITE = &H10
    Public Const TVTTPC0_ENCRYPT = &H20
    Public Const TVTTPC0_DECRYPT = &H40

    Public Const TVTTPC1_CNT_READ = &H1
    Public Const TVTTPC1_CNT_WRITE = &H2
    Public Const TVTTPC1_CNT_CONFIG = &H4
    Public Const TVTTPC1_ENCRYPT_PASS = &H8
    Public Const TVTTPC1_DECRYPT_PASS = &H10
    Public Const TVTTPC1_CNT_ENCRYPT_PASS = &H20
    Public Const TVTTPC1_WRITE_ENABLED = &H40
    Public Const TVTTPC1_CONFIG_ENABLED = &H80

    'bity konfiguracji licznikw
    Public Const TVTTCC0_WRITE = &H1
    Public Const TVTTCC0_READ = &H2
    Public Const TVTTCC0_INC_READ = &H4
    Public Const TVTTCC0_DEC_READ = &H8
    Public Const TVTTCC0_INC_ENCRYPT_READ = &H10
    Public Const TVTTCC0_STOP_AT_ZERO = &H20
    Public Const TVTTCC0_NVMEM_READ = &H40
    Public Const TVTTCC0_NVMEM_WRITE = &H80

    Public Const TVTTCC1_PASS = &H1
    Public Const TVTTCC1_CONFIG_ENABLED = &H80

    Public RandKeyA(15) As Byte                            ' generator liczb pseudolosowych - pierwsza poowa klucza generatora
    Public RandKeyB(15) As Byte                            ' generator liczb pseudolosowych - pierwsza poowa klucza generatora
    Public RandCnt(15) As Byte                             ' generator liczb pseudolosowych - licznik wywoa generatora liczb pseudolosowych
    Public RandRand((16 * 32) - 1) As Byte                 ' generator liczb pseudolosowych - bufor na kolejk zdarze losowych
    Public RandRandNr(255) As Byte                         ' generator liczb pseudolosowych - licznik kolejkowania zdarze losowych
    Public RandRandCnt(31) As Long

    '*****************************************************************************
    'Funkcja liczy blok kontrolny wiadomoci i umieszcza go w drugim bloku danych
    'We:
    'Adresy na oba bloki danych
    'Wy:
    'wyliczony blok autoryzacji zapisany do drugiego bloku danych
    '*****************************************************************************

    Public Sub TVTT_CalcAuth(ByRef DataA() As Byte, ByRef DataB() As Byte)

        Dim SrcPtr As Integer
        Dim DstPtr As Integer

        ' wypenienie bloku kontrolnego wartoci 0xFF
        DstPtr = 0
        While (DstPtr < 12)
            DataB(TVTTD_AUTH + DstPtr) = &HFF
            DstPtr = DstPtr + 1
        End While

        ' doczenie do obszaru kontrolnego, danych pierwszego bloku danych
        DstPtr = 0

        SrcPtr = 0
        While (SrcPtr < 16)
            DataB(TVTTD_AUTH + DstPtr) = DataB(TVTTD_AUTH + DstPtr) Xor DataA(SrcPtr)
            DstPtr = (DstPtr + 1) Mod 12
            SrcPtr = SrcPtr + 1
        End While

        ' doczenie do obszaru kontrolnego, danych drugiego bloku danych
        SrcPtr = 0
        While (SrcPtr < TVTTD_AUTH)
            DataB(TVTTD_AUTH + DstPtr) = DataB(TVTTD_AUTH + DstPtr) Xor DataB(SrcPtr)
            DstPtr = (DstPtr + 1) Mod 12
            SrcPtr = SrcPtr + 1
        End While
    End Sub


    '*****************************************************************************
    'Funkcja sprawdza poprawno bloku kontrolnego wiadomoci
    'We:
    'Adresy na oba bloki danych
    'Wy:
    '0 - blok kontrolny poprawny lub !0 - blok kontrolny nie poprawny
    '
    '*****************************************************************************
    Public Function TVTT_CheckAuth(ByRef DataA() As Byte, ByRef DataB() As Byte) As Byte

        Dim SrcPtr As Integer
        Dim DstPtr As Integer

        ' "usunicie" z obszaru kontrolnego, danych pierwszego bloku danych
        DstPtr = 0

        SrcPtr = 0
        While (SrcPtr < 16)
            DataB(TVTTD_AUTH + DstPtr) = DataB(TVTTD_AUTH + DstPtr) Xor DataA(SrcPtr)
            DstPtr = (DstPtr + 1) Mod 12
            SrcPtr = SrcPtr + 1
        End While

        ' "usunicie" z obszaru kontrolnego, danych drugiego bloku danych
        SrcPtr = 0
        While (SrcPtr < TVTTD_AUTH)
            DataB(TVTTD_AUTH + DstPtr) = DataB(TVTTD_AUTH + DstPtr) Xor DataB(SrcPtr)
            DstPtr = (DstPtr + 1) Mod 12
            SrcPtr = SrcPtr + 1
        End While

        ' sprawdzenie czy blok kontrolny wypeniony wartoci 0xFF
        DstPtr = 0
        While (DstPtr < 12)
            If (DataB(TVTTD_AUTH + DstPtr) <> &HFF) Then  ' bd w bloku kontrolnym
                TVTT_CheckAuth = 1
                Exit Function
            End If
            DstPtr = DstPtr + 1
        End While

        TVTT_CheckAuth = 0                                ' blok kontrolny poprawny
    End Function

    '*****************************************************************************
    'Funkcja wylicza klucz sesji
    'We:
    'Adres na wyliczony klucz sesji (adres na tablic docelow)
    'Haso PC
    'Tablica losowa PC
    'Haso Tokenu
    'Tablica losowa Tokenu
    'Wy:
    'wyliczony klucz sesji wpisany do podanej tablicy
    '*****************************************************************************
    Public Sub TVTT_CalcSessionKey(ByRef SessionKey() As Byte, ByVal PassPC() As Byte, ByVal RandPC() As Byte, ByVal PassT() As Byte, ByVal RandT() As Byte)

        Dim i As Integer
        Dim Data(15) As Byte

        i = 0                                             ' skopiowanie tablicy losowej PC do bufora
        While (i < 16)
            Data(i) = RandPC(i)
            i = i + 1
        End While

        rijndaelEncrypt(PassT, 0, Data, 0)                ' zaszyfrowanie tablicy losowej PC hasem Tokenu

        i = 0                                             ' przepisanie uzyskanej czsci klucza do tablicy klucza sesji
        While (i < 16)
            SessionKey(i) = Data(i)
            i = i + 1
        End While

        i = 0                                             ' skopiowanie tablicy losowej Tokenu do bufora
        While (i < 16)
            Data(i) = RandT(i)
            i = i + 1
        End While

        rijndaelEncrypt(PassPC, 0, Data, 0)               ' zaszyfrowanie tablicy losowej Tokenu hasem PC

        i = 0                                             ' poczenie pierwszej czsci klucza sesji z uzyskan drug czsci klucza sesji
        While (i < 16)
            SessionKey(i) = SessionKey(i) Xor Data(i)
            i = i + 1
        End While

        i = 0                                             ' wyczyszczenie bufora pomocniczego
        While (i < 16)
            Data(i) = 0
            i = i + 1
        End While
    End Sub

    '*****************************************************************************
    'Funkcja rozszyfrowuje lub szyfruje podany blok danych
    'We:
    'Adres na blok do zaszyfrowania
    'Klucza szyfrowania wiadomoci
    'Haso sesji
    'Numer bloku danych (0-blok pierwszy, 1-blok drugi)
    'Kierunek przesyania wiadomoci (0 - PC->Token, 1 - Token->PC)
    'Wy:
    'zaszyfrowany blok danych
    '*****************************************************************************
    Public Sub TVTT_CryptBlock(ByRef Block() As Byte, ByVal Key As Long, ByVal Pass() As Byte, ByVal BlockNr As Byte, ByVal Direction As Byte)

        Dim i As Integer
        Dim HashTable(15) As Byte


        If (Key = 0) Then Exit Sub                        ' Key=0 jest znacznikiem wiadomoci nieszyfrowanej -> wyjcie

        i = 0                                             ' wyczyszczenie tablicy mieszajcej
        While (i < 16)
            HashTable(i) = 0
            i = i + 1
        End While

        HashTable(0) = Key And &HFF                       ' przygotowanie do generowania klucza tymczasowego - wpisanie klucza szyfrowania wiadomoci do tablicy wynikowej
        Key = Key \ &H100
        HashTable(1) = Key And &HFF
        Key = Key \ &H100
        HashTable(2) = Key And &HFF

        HashTable(3) = BlockNr And &HFF                   ' przygotowanie do generowania klucza tymczasowego - doczenie numeru bloku danych
        HashTable(4) = Direction And &HFF                 ' przygotowanie do generowania klucza tymczasowego - doczenie znacznika kierunku przesyu wiadomoci
        rijndaelEncrypt(Pass, 0, HashTable, 0)            ' wygenerowanie hasa tymczasowego

        i = 0                                             ' rozszyfrowanie lub zaszyfrowanie bloku oraz wyczyszczenie tablicy mieszajcej
        While (i < 16)
            Block(i) = Block(i) Xor HashTable(i)
            HashTable(i) = 0
            i = i + 1
        End While
    End Sub

    '*****************************************************************************
    'Funkcja dodaje zdarzenia losowe do generatora liczb pseudolosowych
    'We:
    '   Numer rda zdarze losowych
    '   Warto zdarzenia
    '
    '*****************************************************************************

    Public Sub TVTT_Randomize(ByVal SrcNr As Byte, ByVal Data As Long)

        Dim Buff(15) As Byte
        Dim n As Byte
        Dim RandOffset As Long

        ' zwikszenie licznika danych w kolejce
        If (RandRandCnt(RandRandNr(SrcNr And &HFF) And 31) <> &HFFFFFFFF) Then
            RandRandCnt(RandRandNr(SrcNr And &HFF) And 31) = RandRandCnt(RandRandNr(SrcNr And &HFF) And 31) + 1
        End If

        ' wyliczenie offsetu na kolejke i zwikszenie licznika kolejek
        RandOffset = (RandRandNr(SrcNr And &HFF) And 31) * 16
        RandRandNr(SrcNr) = (RandRandNr(SrcNr) + 1) And 31

        ' wyczyszczenie bufora i wpisanie do niego danych o zdarzeniu
        n = 0
        While (n < 16)
            Buff(n) = 0
            n = n + 1
        End While

        Buff(0) = SrcNr
        Buff(1) = Data And &HFF
        Data = Data \ &H100
        Buff(2) = Data And &HFF
        Data = Data \ &H100
        Buff(3) = Data And &HFF
        Data = Data \ &H100
        Buff(4) = Data And &HFF

        ' pomieszanie danych o zdarzeniu z danymi z kolejki
        rijndaelEncrypt(RandRand, RandOffset, Buff, 0)

        ' wpisanie nowych danych do kolejki i zamazanie zawartoci bufora
        n = 0
        While (n < 16)
            RandRand(n + RandOffset) = Buff(n)
            Buff(n) = 0
            n = n + 1
        End While
    End Sub

    '*****************************************************************************
    'Funkcja generuje 16-bajtowy blok pseudolosowy
    'We:
    '   Adres na blok do wypenienia wartociami losowymi
    'Wy:
    '   blok danych pseudolosowych
    '
    '*****************************************************************************

    Public Sub TVTT_Rand(ByRef Rand() As Byte, ByVal randOffset As Int16)

        Dim n As Long
        Dim i As Byte
        Dim NewKeyA(15) As Byte
        Dim NewKeyB(15) As Byte
        Dim tmp As Long

        ' obsuga mieszania z danymi losowymi

        n = 0
        While (n < 32)                                    ' przejrzenie wszystkich kolejek pod kontem iloci zdarze w kolejce
            tmp = (1 * (2 ^ n) And &HFFFFFFFF)
            If RandRandCnt(n) > tmp Then ' sprawdzenie czy wystarczajco duzo zdarze
                ' jesli do zdarze to wymieszanie zdarze z kluczem generacji
                ' przekopiowanie aktualnych zdarze i wyczyszczenie kolejki
                i = 0
                While (i < 8)
                    NewKeyA(i) = RandRand(i + (n * 16) + randOffset)
                    NewKeyB(i) = RandRand(i + 8 + (n * 16) + randOffset)
                    NewKeyA(i + 8) = 0
                    NewKeyB(i + 8) = 0
                    RandRand(i + (n * 16) + randOffset) = 0
                    RandRand(i + 8 + (n * 16) + randOffset) = 0
                    i = i + 1
                End While

                ' wygenerowanie nowego klucza
                rijndaelEncrypt(RandKeyA, 0, NewKeyA, 0)
                rijndaelEncrypt(RandKeyB, 0, NewKeyB, 0)

                ' zapisanie nowych kluczy generacji i wyczyszczenie buforw pomocniczych
                i = 0
                While (i < 16)
                    RandKeyA(i) = NewKeyA(i)
                    RandKeyB(i) = NewKeyB(i)
                    NewKeyA(i) = 0
                    NewKeyB(i) = 0
                    i = i + 1
                End While
            End If
            n = n + 1
        End While

        ' przekopiowanie aktualnego stanu licznika
        n = 0
        While (n < 16)
            Rand(n) = RandCnt(n)
            n = n + 1
        End While

        ' zwikszenie licznika
        If (RandCnt(0) + 1) > 255 Then
            RandCnt(0) = 0
        Else
            RandCnt(0) = RandCnt(0) + 1                   ' zwikszenie najmlodszego bajtu
        End If

        n = 1
        While (n < 16)                                    ' sprawdzenie przeniesienia na starszy bajt    
            If (RandCnt(n - 1) <> 0) Then                 ' sprawdzenie czy modszy bajt wyzerowany
                If RandCnt(n) = 255 Then
                    RandCnt(n) = 0
                Else
                    RandCnt(n) = RandCnt(n) + 1           ' wyzerowany - moliwe tylko gdy nastpio przeniesienie -> zwikszenie starszego bajtu
                End If
            Else
                Exit While                                ' nie wyzerowany - nie wystpio przeniesienie -> koniec ptli
            End If
            n = n + 1
        End While

        ' wygenerowanei wartoci wyjciowej (pseudolosowej)
        rijndaelEncrypt(RandKeyA, 0, Rand, 0)
        rijndaelEncrypt(RandKeyB, 0, Rand, 0)

        ' wygenerowanie nowego pierwszego klucza

        ' przekopiowanie aktualnego stanu licznika
        n = 0
        While (n < 16)
            NewKeyA(n) = RandCnt(n)
            n = n + 1
        End While

        ' zwikszenie licznika
        If (RandCnt(0) + 1) > 255 Then
            RandCnt(0) = 0
        Else
            RandCnt(0) = RandCnt(0) + 1                   ' zwikszenie najmlodszego bajtu
        End If

        n = 1
        While (n < 16)                                    ' sprawdzenie przeniesienia na starszy bajt
            If (RandCnt(n - 1) <> 0) Then                 ' sprawdzenie czy modszy bajt wyzerowany
                If RandCnt(n) = 255 Then
                    RandCnt(n) = 0
                Else
                    RandCnt(n) = RandCnt(n) + 1           ' wyzerowany - moliwe tylko gdy nastpio przeniesienie -> zwikszenie starszego bajtu
                End If
            Else
                Exit While                                ' nie wyzerowany - nie wystpio przeniesienie -> koniec ptli
            End If
            n = n + 1
        End While

        ' wygenerowanie nowego klucza
        rijndaelEncrypt(RandKeyA, 0, NewKeyA, 0)
        rijndaelEncrypt(RandKeyB, 0, NewKeyA, 0)

        ' wygenerowanie nowego drugiego klucza

        ' przekopiowanie aktualnego stanu licznika
        n = 0
        While (n < 16)
            NewKeyB(n) = RandCnt(n)
            n = n + 1
        End While

        ' zwikszenie licznika
        If (RandCnt(0) + 1) > 255 Then
            RandCnt(0) = 0
        Else
            RandCnt(0) = RandCnt(0) + 1                   ' zwikszenie najmlodszego bajtu
        End If

        n = 1
        While (n < 16)                                    ' sprawdzenie przeniesienia na starszy bajt    
            If (RandCnt(n - 1) <> 0) Then                 ' sprawdzenie czy modszy bajt wyzerowany
                If RandCnt(n) = 255 Then
                    RandCnt(n) = 0
                Else
                    RandCnt(n) = RandCnt(n) + 1           ' wyzerowany - moliwe tylko gdy nastpio przeniesienie -> zwikszenie starszego bajtu
                End If
            Else
                Exit While                                ' nie wyzerowany - nie wystpio przeniesienie -> koniec ptli
            End If

            n = n + 1
        End While

        ' wygenerowanie nowego klucza
        rijndaelEncrypt(RandKeyA, 0, NewKeyB, 0)
        rijndaelEncrypt(RandKeyB, 0, NewKeyB, 0)

        ' zapamitanie nowych kluczy i wyczyszczenie buforw pomocniczych
        n = 0
        While (n < 16)
            RandKeyA(n) = NewKeyA(n)
            RandKeyB(n) = NewKeyB(n)
            NewKeyA(n) = 0
            NewKeyB(n) = 0
            n = n + 1
        End While
    End Sub

    '*****************************************************************************
    'Funkcja inicjuje generator liczb pseudolosowych
    'We:
    '   Adres na blok danych inicjujcych
    '
    '*****************************************************************************

    Public Sub TVTT_RandInit(ByRef Init() As Byte)

        Dim n As Long

        ' rozszyfrowanie tablic
        n = 1
        While (n < 4)
            rijndaelDecrypt(Init, 0, Init, n * 16)
            n = n + 1
        End While

        ' usunicie mieszania tablic
        n = 16
        While (n < (16 * 4))
            Init(n) = Init(n) Xor n
            n = n + 1
        End While

        ' przepisanie danych z bloku do tablic
        n = 0
        While (n < 16)
            RandKeyA(n) = Init(n + 16)
            RandKeyB(n) = Init(n + 32)
            RandCnt(n) = Init(n + 48)
            n = n + 1
        End While
    End Sub

    '*****************************************************************************
    'Funkcja zwraca blok danych do uycia przy nastpnej inicjalizacji generatora
    '   liczb pseudolosowych
    'We:
    '   Adres na blok do ktrego zapis danych opisujcych stan generatora
    'Wy:
    '   Blok danych opisujcych stan generatora
    '
    '*****************************************************************************

    Public Sub TVTT_RandGetInit(ByRef Init() As Byte)
        TVTT_Rand(Init, 0)
        TVTT_Rand(Init, 16)
        TVTT_Rand(Init, 32)
        TVTT_Rand(Init, 48)
    End Sub

End Module

